//
//  AZFileManager.m
//  Run BPM
//
//  Created by Paolo Rossignoli on 18/11/13.
//  Copyright (c) 2013 Paolo Rossignoli. All rights reserved.
//

#import "AZFileManager.h"

@implementation AZFileManager

- (void) copyFileName:(NSString*)fileName fromPath:(NSString*)tempFilePath
{
    NSString *workSpacePath=[[AZFileManager documentsDirectory] stringByAppendingPathComponent:fileName];
    [tempFilePath writeToFile:workSpacePath
                   atomically:YES
                     encoding:NSUTF8StringEncoding
                        error:nil];
    NSLog(@"tempFilePath %@",tempFilePath);
}


#pragma mark FILE CON GESTIONE AUTONOMA
+ (AZFileManager*)sharedManager {
    static dispatch_once_t once;
    static AZFileManager *sharedManager;
    dispatch_once(&once, ^ { sharedManager = [[AZFileManager alloc] init]; });
    return sharedManager;
}

+ (NSString *)documentsDirectory {
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentDirectory = [paths objectAtIndex:0];
    return documentDirectory;
}

+ (NSString*) cachesDirectory {
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES);
    NSString *cachesDirectory = [paths objectAtIndex:0];
    return cachesDirectory;
}

+ (BOOL) fileExistsInDocumentsDirectory:(NSString *)fileName
{
	NSFileManager *fileManager = [NSFileManager defaultManager];
	NSString *fileInResourcesFolder = [[AZFileManager documentsDirectory] stringByAppendingPathComponent:fileName];
    return [fileManager fileExistsAtPath:fileInResourcesFolder];
}

+ (void) deleteFile:(NSString*)fileName {
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
	NSString *fileInResourcesFolder = [[AZFileManager documentsDirectory] stringByAppendingPathComponent:fileName];
    
    NSError *error = nil;
    [fileManager removeItemAtPath:fileName error:&error];
    
    BOOL deleted = [fileManager removeItemAtPath:fileInResourcesFolder error:&error];
    
    if (deleted != YES || error != nil)
    {
        // Deal with the error...
        NSLog(@"ERRORE \n deleteFile: %@",error);
    }
}

+ (void) deleteFileInDocumentDirectory:(NSString*)fileName {
    NSFileManager *fileManager = [NSFileManager defaultManager];
	NSString *fileInResourcesFolder = [[AZFileManager documentsDirectory] stringByAppendingPathComponent:fileName];
    
    NSError *error = nil;
    //[fileManager removeItemAtPath:fileInResourcesFolder error:&error];
    
    /*
     BOOL deleted = [fileManager removeItemAtPath:fileInResourcesFolder error:&error];
     
     if (deleted != YES || error != nil)
     {
     // Deal with the error...
     NSLog(@"ERRORE \n deleteFile: %@",error);
     }
     */
    
    BOOL success=[AZFileManager fileExistsInDocumentsDirectory:fileName];
    if (success)
    {
        BOOL deletedFile = [fileManager removeItemAtPath:fileInResourcesFolder error:&error];
        if (deletedFile){
            NSLog(@"File %@ cancellato",fileName);
        }
        else {
            NSLog(@"Not able to delete File");
            NSLog(@"ERRORE \n deleteFile: %@",error);
        }
    } else {
         NSLog(@"il file %@ non esiste",fileName);
    }
    
}

+ (void) deleteAllFilesInDocumentDirectory {
    
    
    // Path to the Documents directory
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    if ([paths count] > 0)
    {
        NSError *error = nil;
        NSFileManager *fileManager = [NSFileManager defaultManager];
        
        // Print out the path to verify we are in the right place
        NSString *directory = [paths objectAtIndex:0];
        NSLog(@"Directory: %@", directory);
        
        // For each file in the directory, create full path and delete the file
        for (NSString *file in [fileManager contentsOfDirectoryAtPath:directory error:&error])
        {
            NSString *filePath = [directory stringByAppendingPathComponent:file];
            NSLog(@"File : %@", filePath);
            
            BOOL fileDeleted = [fileManager removeItemAtPath:filePath error:&error];
            
            if (fileDeleted != YES || error != nil)
            {
                // Deal with the error...
            }
        }
        //[self deleteAllFilesInCache];
        //[self.delegate deleteComplete:self];
    }
}

+ (void) deleteAllFilesInCache {
    NSFileManager *fileMgr = [NSFileManager defaultManager];
    NSArray *fileArray = [fileMgr contentsOfDirectoryAtPath:[AZFileManager cachesDirectory] error:nil];
    for (NSString *filename in fileArray)  {
        [fileMgr removeItemAtPath:[[AZFileManager cachesDirectory] stringByAppendingPathComponent:filename] error:NULL];
    }
}


@end
